 _clkmode = xtal1 + pll16x                                     'Clock Speed
 _xinfreq = 5_000_000                                          'Cystal Speed
'' ==================================================================================
''
''   File....... Buttonpush.spin
''   Purpose.... Turns Leds on pin 0 to pin 7 on when button is pushed on pin 24 
''   Author..... BillyS (aka Lockadoc)
''   E-mail..... Lockadoc@Aol.Com
''   Started.... 10 Oct 2009
''   Updated.... 12 JFeb 2010
''
'' ====================================================================================
  

 MS_001   = 80_000_000 / 1_000                                      ' ticks per millisecond   

Var
 long buttonStack[10]                                               'Stack Space for the new cog
 byte buttoncogId                                                   'Store new cog ID

Pub Start                                                           'Starts the new cog method
  Stop                                                              'Prevents multiple starts of this method
  buttoncogid := cognew (buttonpush, @buttonStack)+1                'Starts and gets a cog ID

  
Pub Stop                                                            'Stops the cog that was started  
   if buttonCogId > -1
    cogstop (buttoncogId-1)
 

Pub ButtonPush
   
   dira[0..7] :=%11111111                                           ' leds 0 to 7 made outputs
     repeat
      if ina[24]                                                    ' button 24 input
         outa[0..7] := %11111111                                    ' leds on
          pause (800_000)                                           ' time for Leds to stay on 800_000 = about  13 minutes
   
      outa[0..7] :=%00000000                                        ' turn Leds off

pub pause(ms) | t                                                   ' used for making a pause

  t := cnt                                                          ' sync with cnt
  repeat ms
    waitcnt(t += MS_001)                                            ' wait one millisecond  

      