'' ==================================================================================
''
''   File....... Traffic.spin
''   Purpose.... Controls a three light traffic light  
''   Author..... BillyS (aka Lockadoc)
''   E-mail..... Lockadoc@Aol.Com
''   Started.... 10 Oct 2009
''   Updated.... 2 Feb 2010
''
'' ====================================================================================


'traffic light object  
'in a new cog  pin 19 goes high ,upon input on pin 14 one second later pin 19 goes low while pin 20 goes high
'two seconds later pin 20 goes low while pin 21 goes high, after twenty seconds pin 21 goes low while  pin
'19 returns to high  

 
 _clkmode = xtal1 + pll16x                                     'Clock Speed
 _xinfreq = 5_000_000                                          'Cystal Speed
 MS_001   = 80_000_000 / 1_000                                 ' ticks per millisecond    
                  
Var                                                      
 long trafficStack[10]                                         'Stack Space for the new cog
 byte trafficcogId                                             'Store new cog ID
 byte trafficlightcogId  
Obj
  
      
  
Pub Start                                                       'Starts the new cog method
  Stop                                                          'Prevents multiple starts of this method
  trafficcogid := cognew (trafficpush, @trafficStack)+1         'Starts and gets a cog ID

  
Pub Stop                                                        'Stops the cog that was started  
   if trafficCogId > -1
    cogstop (trafficcogId-1)
     

Pub trafficPush
   
   dira[19..21] :=%111                                          ' leds 19 to 21 made outputs
     repeat
      outa [19] :=%1                                            ' turns green light on
      if ina[14]                                                ' with button pin14 input
       pause(1_000)                                             ' delays for 1 second    
       outa [19] :=%0                                           ' turns off green light
       outa [20] :=%1                                           ' turns on yellow light
       pause (2_000)                                            ' delays for 2 seconds
       outa [20] :=%0                                           ' turns yellow light off
       
       outa [21] :=%1                                           ' turns red light on
       pause (20_000)                                           ' delays 20 seconds
       outa [21] :=%0                                           ' turns off red light
     
pub pause(ms) | t

  t := cnt                                                      ' sync with cnt
  repeat ms
    waitcnt(t += MS_001)                                        ' wait one millisecond  
     
' pause(30_000)                                                 ' run for 30 seconds         